SystemOrganization addCategory: #'SDL-Tests-FFI'!

Phexample subclass: #SDLFFITests
	instanceVariableNames: 'sdl'
	classVariableNames: ''
	poolDictionaries: 'SDLConstants'
	category: 'SDL-Tests-FFI'!

!SDLFFITests methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/8/2012 19:09'!
setUp
	sdl := SDLLibrary new.! !

!SDLFFITests methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/3/2012 20:50'!
tearDown! !

!SDLFFITests methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/3/2012 21:31'!
testCreateWindow
	| window title |
	self given: #testInit.
	window := sdl SDL_CreateWindow: 'testWindow' x: 10 y: 10 w: 100 h: 100 flags: 0.
	self assert: window isNull not.
	title := sdl SDL_GetWindowTitle: window.
	self assert: title = 'testWindow'.
	^ window! !

!SDLFFITests methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/3/2012 21:32'!
testDestroyWindow
	| window |
	window := self given: #testCreateWindow.
	sdl SDL_DestroyWindow: window.
! !

!SDLFFITests methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/3/2012 20:52'!
testInit
	self assert: 0 = (sdl SDL_Init: SDL_INIT_VIDEO).
	self assert: SDL_INIT_VIDEO = (SDL_INIT_VIDEO bitOr: (sdl SDL_WasInit: SDL_INIT_VIDEO)).! !

!SDLFFITests methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/8/2012 20:10'!
testPollEvent
	| window event types |
	window := self given: #testCreateWindow.

	[
		event := SDL_Event new.
		types := OrderedCollection new. 

		[ (sdl SDL_PollEvent: event) = 1 ]
			whileTrue: [
				types add: event type.
			].
		self assert: types isEmpty not.
		self assert: (types includes: SDL_WINDOWEVENT).

	] ensure: [ sdl SDL_DestroyWindow: window. ]! !

!SDLFFITests methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/8/2012 20:10'!
testVersion
	| version |
	self given: #testInit.
	version := SDL_version new.
	sdl SDL_GetVersion: version.
	self assert: version major >= 1.
	self assert: version minor <= 10.
	self assert: version patch <= 30.
! !
